\name{CatCall}
\alias{CatCall}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Visual Analysis of Period and Phase
        %%  ~~function to do ... ~~
}
\description{ Perform one or more analyses to gain insight into periods and/or phase in a dataset:  Actogram, Smoothing, Autocorrelation or Crosscorrelation.
              
              (** In time formats such as “_Y_m_d_H_M”, the underscore symbol, “_”, represents a percent sign – which is not allowed in this help file)
              %%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{  
  CatCall(TimeCol=1, timeFormat="_Y_m_d_H_M",lum=4, valCols=c(3,4), sumCols=c(5,6), Avg=TRUE, export=F, sizePts=2, binPts=5, Span = 0, Increment=0, k=6, yLab="Activity Level (au)", modulo=1440,Rverbose=0, RmaxGap=400, Skip=0,header=FALSE, Smoothing=F, Actogram=F,AutoCorr=F,CrossCorr=F,Console=F,Graphics="pdf", Darkness1=1,Darkness2=0,LagPcnt=.33,fileName,file2Name=NULL)**
    
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{TimeCol}{ List columns containing the date and time.  List columns containing the date and time.  Can be in one column, date can be in a separate column from time.  In this case, specify c(dateCol, timeCol), i.e., c(3,4).  The format for time will be expected in timeFormat parameter.Time is read to the minute. Seconds are discarded. 
                  %%     ~~Describe \code{TimeCol } here~~
  }
  \item{timeFormat}{Can be "numeric", or any valid R time conversion specification,  i.e., "_Y_m_d_H_M" **.  See strptime for conversion specifications.  A two column time will be concatenated without spaces, and your specified format applied: DateTime.
                    %%     ~~Describe \code{timeFormat } here~~
  }
  \item{lum}{The column number containing luminance values.  Luminance values are used to determine where the light level drops sharply, and this point is used as the starting point for analysis.  Data points prior to this row (LumStart) are not used.
             %%     ~~Describe \code{lum} here~~
  }
  \item{valCols}{Specify which columns contain non-count type data, such as temp or blood pressure.  This is handled differently than count type data.  Specify valCols=c() if none. 
                 %%     ~~Describe \code{valCols} here~~
  }
  \item{sumCols}{Specify which columns contain count type data – activity counts, for example.  Specify sumCols=c() if none. 
                 %%     ~~Describe \code{sumCols} here~~
  }
  \item{Avg}{A boolean to indicate if you would like to see the output of an average of all data columns.  If you tell CAT to analyze columns 4:8, and specify average, each column from 4 to 8 will be analyzed and results output.  Additionally, the columns will be averaged and analyzed.
             %%     ~~Describe \code{Avg} here~~
  }
  \item{export}{Boolean.  Default is False.  If True, a data file is saved of the data after filling in missing values and binning (per parameters). When True, each function (except Actogram) exports function results to separate comma delimited text files.
                %%     ~~Describe \code{export} here~~
  }
  \item{sizePts}{ sizePts is the number of minutes between samples.  
                  %%     ~~Describe \code{sizePts} here~~
  }
  \item{binPts}{ binPts is the number of samples to aggregate into one bin. Binning is very flexible since it can be so important.  sizePts * binPts = number of minutes in each bin.   Only full bins are used for analysis, so there could be a few data points at the end of the data (after binEnd) that are not used.
                 %%     ~~Describe \code{binPts} here~~
  }
  \item{Span}{Span & Increment are two parameters that are used together to specify a progressive analysis.  The span is the length of subsections of data to analyze, and the increment is how far to move ahead in the data to begin the next span.  (Span will need to be large enough not to trigger the error messages in the functions, which require more than 3 days for each analysis.) The entire data set will be analyzed (from LumStart to binEnd).   A progressive analysis can be performed by the Auto-Correlation, Cross-Correlation and Periodogram analyses.  The Actogram and Smoothing functions are performed on the full dataset length, for each column, as normal.  There is no benefit to viewing these graphs in subsections.
              %%     ~~Describe \code{Span} here~~
  }
  \item{Increment}{ Span & Increment are two parameters that are used together to specify a progressive analysis.  The increment is how far to move ahead in the data to begin the next span.  See Span for more information.
                    %%     ~~Describe \code{Span} here~~
  }
  \item{k}{Only the Smoothing function uses this parameter.  It is a count of the number of data points on each side of a point to include in the moving average.  Each moving average is calculated using 2k+1 data points.
           %%     ~~Describe \code{k} here~~
  }
  \item{yLab}{Label for the Y axis on Smoothing and Actogram functions.  Default-"Activity Level (au)"
              %%     ~~Describe \code{yLab} here~~
  }
  \item{modulo}{Only the Actogram function uses this parameter.   It specifies the width in minutes to be used for displaying the Actogram.  Default is 1440 min, or 1 day.  
                %%     ~~Describe \code{modulo} here~~
  }
  \item{Rverbose }{Can take on values of -1, 0,1 or 2.  0 turns off debug information.  1 or 2 add increasing amounts of debug information. -1 minimizes information displayed on graphs.
                   %%     ~~Describe \code{Rverbose} here~~
  }
  \item{RmaxGap}{specifies the maximum allowable number of missing data points in any one block.   An error will be returned if gaps larger than this are found in a data file.
                 %%     ~~Describe \code{RmaxGap} here~~
  }
  \item{header}{ T/F to indicate if the file has a header.  Headers are used as variable names.
                 %%     ~~Describe \code{Skip} here~~
  }
  \item{Skip}{ How many lines to skip at the top of the file (before the header). The header will be read next, after Skip lines are skipped (if header=TRUE).  
               %%     ~~Describe \code{Skip} here~~
  }
  \item{Smoothing}{Default is Smoothing=F;  Smoothing=T will cause this function to run, thus you select only the functions you need for any purpose.
                   %%     ~~Describe \code{Smoothing} here~~
  }
  \item{Actogram}{ Default is Actogram=F;  Actogram=T will cause this function to run, thus you select only the functions you need for any purpose.
                   %%     ~~Describe \code{Actogram} here~~
  }
  \item{AutoCorr}{ Default is AutoCorr=F;  AutoCorr=T will cause this function to run, thus you select only the functions you need for any purpose.
                   %%     ~~Describe \code{AutoCorr} here~~
  }
  \item{CrossCorr}{Default is CrossCorr=F;  CrossCorr=T will cause this function to run, thus you select only the functions you need for any purpose.
                   %%     ~~Describe \code{CrossCorr} here~~
  }   
  \item{Console}{Default is F.  When Console=T output will be redirected to the RStudio Console, instead of an output file.
                 %%     ~~Describe \code{Console} here~~
  }
  \item{Graphics}{Results of CatCall are sent to a file when Console=F.  Default file output type is "pdf".   Possible values: "jpg, pdf, tif, png”.   
                  %%     ~~Describe \code{Console} here~~
  }
                  \item{Darkness1}{ This refers to fileName.  This refers to the illumination column.  CAT analysis and graphing begins at darkness onset, as indicated by the luminance column.  Normally, darkness is indicated by a very small number (<10) and light is a large number (>=10).  If this is needed to be reversed, changing the Darkness 1 or Darkness 2 defaults will correct the interpretation of the lumninance column for file1 or file2, respectively.  Darkness=0 means that darkness is a small number (<10);  Darkness=1 indicates light is a very small number, and darkness is a large number (>=10).. 
                  %%     ~~Describe \code{Darkness1} here~~
                  }
                  \item{ Darkness2}{ This refers to file2Name. Same as Darkness1
                  %%     ~~Describe \code{Darkness2} here~~
                  }
                  \item{LagPcnt}{  Specifies the percent of the data set to use as lag in the calculation for Autocorrelation and Crosscorrelation.
                  %%     ~~Describe \code{LagPcnt} here~~
                  }
                  \item{fileName}{This is a required field, used by all functions.   If this is blank, CATCosinor will solicit a file from the user by a dialogue box.  
                  %%     ~~Describe \code{fileName,file2Name_} here~~
                  }       
                  \item{file2Name}{Optional.  Only needed when running the Crosscorrelation function. 
                  %%     ~~Describe \code{fileName,file2Name_} here~~
                  }  
}
                  \section{Input Data:}{  
                  Input data is assumed to be equidistant, discrete, except for the luminance column, and the adjacent column to the left of lumninance (which may be temperature, but is not currently processed in CAT).  (Although CAT can be adapted easily to accept a parameter that will allow continuous data.)  An error will be reported if less than three days of data is provided in a file.  All columns are expected to be numeric.  
                  Data File format:  Tab delimited (.txt) or comma delited (.csv) file 
                  A single data file with many data columns can be specified for analysis, in which case the Cross-Correlation function is skipped; or 2 data sets can be analyzed.  In all cases, interpolation is done to fill in missing data points; and then analysis is done on each specified data column in a file, as well as on the average of all columns individually analyzed (if Avg=T).  
                  }
                  \section{Output Data:}{  
                  Sample graphics output file:  See Output section on the web site for a sample of a full output file.  All graphs have the input data filename to clearly identify the data file under analysis, and a timestamp to show the time of analysis.  Each graph also lists the column name being analyzed (or averaged), and the starting and ending times of analysis, as they vary slightly from the full data set (Lum to binEnd).    
                  Graphic output files can be in jpg, pdf, TIFF or png.  TIFF and PNG are higher resolution than jpeg and pdf.  Plots in PNG and JPEG formats can easily be converted to many other bitmap formats, and both can be displayed in modern web browsers. The PNG format is lossless and is best for line diagrams and blocks of color. The JPEG format is lossy, but may be useful for image plots, for example. It is most often used in html web pages.  TIFF is a meta-format: the default format written by tiff is lossless and stores RGB (and alpha where appropriate) values uncompressed—such files are widely accepted, which is their main virtue over PNG.
                  Output Data files:  The input data is interpolated and binned.  This transformed data can be exported using the export parameter.  If export=T then each function (except Actogram) exports a file with the results of the function. 
                  %%  ~~ If necessary, more details than the description above ~~
                  }      
                  
                  \references{http://564394709114639785.weebly.com/running-cat.html
                  %% ~put references to the literature/web site here ~
                  }
                  \author{Cathy Lee Gierke, Germaine Cornelissen-Guillaume, John A Lindgren, Ruth Ann Helget
                  
                  Maintainer: \email{ <leegi001@umn.edu>}
                  }
                  %%  ~~who you are~~
                  
                  %% ~Make other sections like Warning with \section{Warning }{....} ~
                  
                  \examples{
                  #---------------------   Vignette3      visualization
                  
                  filePath<-"~/file/path/Installing CAT/Vignette3"          # use for mac
                  #filePath<-"c:\\file\\path\\Installing CAT\\Vignette3"     # use for PC
                  fileName<-file.path(filePath,'activity stress c57--stress copy2-part.txt')
                  file2Name<-file.path(filePath,'good-6d-2m-part.txt')
                  
                  CatCall(TimeCol=c(1,2), timeFormat="_d/_m/_y _H:_M:_S",lum=NA, valCols=5, sumCols=c(), Avg=FALSE, export=TRUE, sizePts=2, binPts=1, Span = 0, Increment=0, k=5, yLab=NA, modulo=1440, Rverbose=0, RmaxGap=3000, Skip=0, header=TRUE, Smoothing=T, Actogram=T,AutoCorr=T,CrossCorr=T,Console=F,Graphics="pdf", Darkness1=0, Darkness2=0,fileName=fileName,file2Name=file2Name,LagPcnt=1)**
                  }
                  
                  
                  % Add one or more standard keywords, see file 'KEYWORDS' in the
                  % R documentation directory.
                  \keyword{ ~ Actogram }
                  \keyword{ ~ Smoothing }
                  \keyword{ ~ Autocorrelation }
                  \keyword{ ~ Crosscorrelation }
                  \keyword{ ~ cosinor }
                  \keyword{ ~ chronomics }